10 ' Version 1.2, 16-apr-83
20 ' BIZ-CALC - Copyright (C) 1983 by the Wizard of OsZ, (213) 709-6969
30 ' Wizard of OsZ, 9614C Cozycroft Ave., Chatsworth, CA. 91311 U.S.A. 
40 ' ---------------- Osborne I Terminal Commands --------------------
50 E$=CHR$(27): '                 Escape Character
60 CLS$=CHR$(26): '               Clear Screen
70 DC$=E$+"=": '                  Direct Cursor Addressing
80 GY$=E$+"g": '                  Graphics On
90 GN$=E$+"G": '                  Graphics Off
100 HO$=E$+CHR$(30): '             Cursor Home
110 EP$=E$+"T": '                 Erase to End of Line
120 DY$=E$+")": '                 DIM Display On
130 DN$=E$+"(": '                 DIM Display Off
140 UY$=E$+"l": '                 Start Underlining
150 UN$=E$+"m": '                 End Underlining
160 RE$=CHR$(13): '               Carriage Return
170 BS$=CHR$(8): '                Backspace
180 BU$=CHR$(19): '               Backup
190 BE$=CHR$(7): '                Bell
200 US$="_": '                    Underscore
210 BL$=" ": '                    Blank (space)
220 NU$="": '                     Null
230 CO$=DC$+"9"+" ": '            Cursor Off (cursor off display screen)
240 PRINT CLS$ ' signin please...
250 PRINT "    The Wizard of OsZ - 'BIZ-CALC' - Version 1.2"
260 PRINT "        Copyright (C) 1983, by Wizard of OsZ"
270 CLOSE
280 SC=1:PR=2:F1=3: ' device codes
290 MV=20:L3=0:DIM N$(MV),V(MV)
300 DIM I$(80),P$(80),S(80),S$(80) ' infix, postfix expressions, value, operand stacks
310 OU=SC: ' default output to screen 
320 ' print header
330 PRINT:PRINT UY$;STRING$(52," ");UN$
340 PRINT:PRINT SPC(8);"Wizard of OsZ BIZ-WIZ Desk Calculator"
350 PRINT UY$;STRING$(52," ");UN$
360 PRINT:PRINT "Enter formulas, variable assignments, or commands."
370 PRINT:PRINT "Type ";UY$;"HELP";UN$;" for a list of commands.":PRINT
380 ' prompt and get infix expression ' output: T$
390 IF ME$<>NU$ THEN PRINT ME$: ' error message (if any)
400 IF OU=PR AND ME$<>NU$ THEN LPRINT ME$
410 ME$=NU$
420 PRINT:PRINT "Enter: ";: ' prompt for input
430 IF OU=PR THEN LPRINT:LPRINT "Enter: ";
440 LN=80:FC=32:LC=127:GOSUB 1900: ' get line
450 IF EC$="ESC" THEN GOTO 840
460 IF T$=NU$ THEN GOTO 380: ' re-prompt
470 ' parse infix expressions into tokens ' input: T$ ' output: I$(),I
480 N$="NOTVAL":IN$="NOTID": ' value, identifier flags
490 I=0
500 FOR C=1 TO LEN(T$): ' for each character in expression
510    C$=MID$(T$,C,1)
520    IF C$=BL$ THEN GOTO 630
530    GOSUB 1720: ' get character type (TP$)
540    IF TP$="Bad character" THEN ME$=TP$:GOTO 380
550    IF TP$<>"NUMERIC" AND N$="VAL" THEN N$="NOTVAL"
560    IF TP$="OPERATOR" AND IN$="ID" AND C$<>"=" THEN ID$=I$(I):GOSUB 1340:I$(I)=RIGHT$(STR$(NU),LEN(STR$(NU))-1):IF ME$<>NU$ THEN GOTO 380
570    IF TP$="OPERATOR" AND IN$="ID" THEN IN$="NOTID":GOTO 620
580    IF TP$="NUMERIC" AND N$="VAL" THEN GOTO 630
590    IF TP$="ALPHA" AND IN$="NOTID" THEN I=I+1:I$(I)=C$:IN$="ID":GOTO 630
600    IF TP$<>"OPERATOR" AND IN$="ID" THEN I$(I)=I$(I)+C$:GOTO 630
610    IF TP$="NUMERIC" AND N$="NOTVAL" THEN I=I+1:I$(I)=RIGHT$(STR$(VAL(RIGHT$(T$,LEN(T$)-C+1))),LEN(STR$(VAL(RIGHT$(T$,LEN(T$)-C+1))))-1):N$="VAL":GOTO 630
620 IF TP$="OPERATOR" THEN I=I+1:I$(I)=C$:GOTO 630
630 NEXT
640 IF IN$="ID" AND I>1 THEN ID$=I$(I):GOSUB 1340:I$(I)=RIGHT$(STR$(NU),LEN(STR$(NU))-1):IF ME$<>NU$ THEN GOTO 380
650 ' interpret expression ' input: I$(I)
660 IF I=0 THEN GOTO 380
670 LW$=I$(1):GOSUB 860:I1$=UP$
680 C$=LEFT$(I$(1),1):GOSUB 1720
690 IF TP$="NUMERIC" AND I$(2)="=" THEN ME$="Can't assign a value to a number":GOTO 380
700 IF I$(2)="=" AND I>=2 THEN GOSUB 1420:GOTO 380
710 IF I1$="HELP" THEN GOSUB 1780:GOTO 380 ' list commands
720 IF I1$="LIST" THEN GOSUB 1500:GOTO 380 ' list variable values
730 IF I1$="CLEAR" THEN L3=0:FOR N=1 TO MV:N$(N)=NU$:NEXT:GOTO 380
740 IF I1$="PON" THEN OU=PR:GOTO 380: ' output to printer
750 IF I1$="POFF" THEN OU=SC:GOTO 380
760 IF I1$="EXAMPLE1" THEN RESTORE:PRINT CLS$:FOR X=1 TO 11:READ X$:PRINT X$:NEXT:GOTO 380
770 IF I1$="EXAMPLE2" THEN RESTORE:PRINT CLS$:FOR X=1 TO 11:READ X$:NEXT:FOR X=12 TO 23:READ X$:PRINT X$:NEXT:GOTO 380
780 IF I=1 THEN ID$=I$(1):GOSUB 1340:IF ME$=NU$ THEN GOTO 810
790 IF ME$<>NU$ THEN GOTO 380
800 IB=1:GOSUB 940: ' default: evaluate expression
810 PRINT "Result =";NU: ' display numeric answer
820 IF OU=PR THEN LPRINT "Result =";NU
830 GOTO 380: ' end with ESC
840 PRINT CLS$:FOR N=1 TO 11:PRINT:NEXT
850 PRINT SPC(11);"Reloading BIZ-WIZ...Please Wait:"+CO$:CHAIN "A:BIZ-WIZ.BAS"
860 ' translate uppercase to lowercase ' input: LW$ (lowercase string) ' output: UP$ (uppercase string)
870 UP$=NU$
880 FOR N=1 TO LEN(LW$)
890    C$=MID$(LW$,N,1)
900    IF C$>"Z" THEN C$=CHR$(ASC(C$)-32)
910    UP$=UP$+C$
920 NEXT
930 RETURN
940 ' convert infix expression to postfix ' input: I$(),I ' output: P$(),P
950 TP=0:P=0: ' top-of-stack
960 FOR C=IB TO I
970    C$=I$(C)
980    IF C$=")" THEN GOSUB 1610:GOTO 1100 
990    PC=1:PS=1
1000    IF C$<>"/" AND C$<>"*" AND C$<>"-" AND C$<>"+" THEN GOTO 1080
1010    IF C$="*" OR C$="/" THEN PC=2
1020    IF TP=0 THEN PS=0: GOTO 1050
1030    IF S$(TP)="*" OR S$(TP)="/" THEN PS=2
1040    IF S$(TP)="(" THEN PS=0
1050    IF PC>PS THEN TP=TP+1:S$(TP)=C$:GOTO 1100
1060 IF PC<PS THEN P=P+1:P$(P)=S$(TP):TP=TP-1:GOTO 990
1070 IF PC=PS THEN P=P+1:P$(P)=S$(TP):S$(TP)=C$:GOTO 1100
1080    IF C$="(" THEN TP=TP+1:S$(TP)=C$:GOTO 1100
1090    P=P+1:P$(P)=C$ ' identifier
1100 NEXT
1110 GOSUB 1610: ' empty operator stack
1120 ' execute postfixed expression ' input: P$(),P ' output: NU
1130 TP=0: ' stack top
1140 FOR C=1 TO P: ' for each post-fixed token
1150    C$=P$(C)
1160    ' perform arithmetic operation
1170    IF C$="+" THEN TP=TP-1:S(TP)=S(TP)+S(TP+1):GOTO 1230
1180    IF C$="-" THEN TP=TP-1:S(TP)=S(TP)-S(TP+1):GOTO 1230
1190    IF C$="*" THEN TP=TP-1:S(TP)=S(TP)*S(TP+1):GOTO 1230
1200    IF C$="/" AND S(TP)=0 THEN ME$="You can't divide by zero!":GOTO 1250
1210    IF C$="/" THEN TP=TP-1:S(TP)=S(TP)/S(TP+1):GOTO 1230
1220    TP=TP+1:S(TP)=VAL(C$)
1230 NEXT
1240 NU=S(TP): ' the answer...finally!
1250 RETURN
1260 ' put value into variable table ' input: NU,ID$ ' output: ME$
1270 N=0
1280 N=N+1: ' for each variable in the table already
1290    IF N$(N)=ID$ THEN V(N)=NU:GOTO 1330
1300 IF N<L3 THEN GOTO 1280
1310 IF L3=MV THEN ME$="No more variables allowed. ":GOTO 1330
1320 L3=L3+1:N$(L3)=I$(1):V(L3)=NU: ' add value to variable table
1330 RETURN
1340 ' get valye from variable table ' input: ID$ ' output: NU,ME$
1350 N=0
1360 N=N+1: ' for each value in the table
1370    IF N>L3 THEN ME$="Undefined variable":GOTO 1410
1380    IF N$(N)=ID$ THEN NU=V(N):GOTO 1410
1390 GOTO 1360
1400 ME$="Undefined variable"
1410 RETURN
1420 ' assign a value to a variable ' input: I$(),I ' output: IB,ME$
1430 C$=LEFT$(I$(3),1):GOSUB 1720 ' get type
1440 IF I=3 AND TP$="NUMERIC" THEN NU=VAL(I$(3))
1450 IF I=3 AND TP$="ALPHA" THEN ID$=I$(3):GOSUB 1340
1460 IF I>3 THEN IB=3:GOSUB 940: ' postfix and execute
1470 IF ME$<>NU$ THEN GOTO 1500
1480 ID$=I$(1):GOSUB 1260 ' put value into table
1490 RETURN
1500 ' display variables
1510 PRINT:PRINT
1520 IF L3<1 THEN PRINT "No variables set":GOTO 1600
1530 PRINT CLS$;SPC(18);"Set Variables"
1540 PRINT UY$;"                                                    ";UN$:PRINT
1550 IF OU=PR THEN LPRINT "_______________ SET VARIABLES ______________":LPRINT
1560 FOR N=1 TO L3
1570    PRINT N$(N);"=";V(N)
1580    IF OU=PR THEN LPRINT N$(N);"=";V(N) 
1590 NEXT
1600 RETURN
1610 ' empty operator stack
1620 IF TP=0 THEN GOTO 1670
1630 FOR N=TP TO 1 STEP -1
1640    IF S$(TP)<>"(" THEN P=P+1:P$(P)=S$(TP)
1650    TP=TP-1
1660 NEXT
1670 RETURN
1680 ' wait for response
1690 PRINT:PRINT:PRINT:PRINT SPC(13);"Press any key to continue...";
1700 K$=INPUT$(1)
1710 RETURN
1720 ' determine character type ' input: C$ ' output: TP$
1730 TP$="Bad character"
1740 IF (C$>="A" AND C$<="Z") OR (C$>="a" AND C$<="z")THEN TP$="ALPHA"
1750 IF (C$>="0" AND C$<="9") OR C$="." THEN TP$="NUMERIC"
1760 IF C$=")" OR C$="(" OR C$="+" OR C$="-" OR C$="*"OR C$="/" OR C$="=" THEN TP$="OPERATOR"
1770 RETURN
1780 ' list commands
1790 PRINT CLS$:RESTORE:FOR N=1 TO 23:READ X$:NEXT
1800 FOR N=24 TO 42
1810    READ X$
1820    PRINT SPC(6);X$
1830    IF OU=PR THEN LPRINT X$
1840 NEXT
1850 PRINT
1860 PRINT SPC(6);"Need HELP, then type ";UY$;"HELP";UN$;" after colon."
1870 RETURN
1880 ' error routine
1890 ME$="Error in expression":GOTO 380
1900 ' get line ' input: LN,FC,LC ' output: T$,EC$
1910 EC$=NU$:T$=NU$
1920 C=0: ' for each character input
1930 C=C+1: C$=INPUT$(1): ' get character 
1940   IF C$=BU$ THEN C$=BS$:PRINT C$;
1950   IF C$=E$ THEN EC$="ESC":GOTO 2040
1960   IF C$=RE$ THEN PRINT:GOTO 2040
1970   IF (ASC(C$)<FC OR ASC(C$)>LC) AND C$<>BS$ THEN C=C-1:GOTO 1930
1980   IF C$=BS$ AND C=1 THEN PRINT;:GOTO 1910
1990   PRINT C$;:IF OU=PR THEN LPRINT C$; 
2000   IF C$=BS$ AND C<=2 THEN PRINT :PRINT ": ";:GOTO 1900
2010   IF C$=BS$ AND C>2 THEN C=C-2:T$=LEFT$(T$,C):GOTO 1930
2020 IF C=LN THEN T$=T$+C$:GOTO 2040 
2030 T$=T$+C$:GOTO 1930 ' add character and get another
2040 IF OU=PR THEN LPRINT
2050 RETURN
2060 DATA "Simple calculations: "," "," "
2070 DATA "Enter: 2+2","Result = 4"," ","Enter: 5*5","Result = 25"," "
2080 DATA "Enter: 2+(8/2)","Result = 6"
2090 DATA "Assignments: "," "," " 
2100 DATA "Enter: A=15"," ","Enter: A","Result = 15"," "
2110 DATA "Enter: TOTAL=A+15"," ","Enter: TOTAL","Result = 30"
2120 DATA " "
2130 DATA "            List of Commands"
2140 DATA " "
2150 DATA "PON.................Turns Printer ON"
2160 DATA " "
2170 DATA "POFF................Turns Printer OFF"
2180 DATA " "
2190 DATA "LIST................List values of variables"
2200 DATA " "
2210 DATA "CLEAR...............Clears all variables"
2220 DATA " "
2230 DATA "HELP................List these commands"
2240 DATA " "
2250 DATA "EXAMPLE1............Simple calculations"
2260 DATA " "
2270 DATA "EXAMPLE2............Variable assignments"
2280 DATA " "
2290 DATA "ESC Key.............Reload BIZ-WIZ"
2300 DATA " "
2310 END
PLE2............Variable assignme